## cduce 0.3.2

=== Makefile ===
include Makefile.conf
VERSION = 0.3.2

ALL_TARGET=cduce cduce_lib.cma
INSTALL_BINARIES=cduce$(EXE)

ifneq ($(ML_INTERFACE), false)
  ALL_TARGET += cdo2ml mlcduce_wrapper
  INSTALL_BINARIES += cdo2ml$(EXE) mlcduce_wrapper$(EXE) cduce_mktop
endif


all: $(ALL_TARGET)
ifeq ($(NATIVE),true)
all: cduce_lib.cmxa
endif

PACKAGES = ulex camlp4 num cgi pcre netstring 


# Call make with VERBOSE=true to get a trace of commands

VERBOSE=false

ifneq ($(VERBOSE), true)
   HIDE=@
else
   HIDE=
endif


SYNTAX = -I misc/ q_symbol.cmo \
  -symbol cduce_version=\"$(VERSION)\" \
  -symbol build_date=\"$(shell date +%Y-%m-%d)\" \
  -symbol session_dir=\"$(SESSION_DIR)\"

SYNTAX_PARSER = -syntax camlp4o $(SYNTAX:%=-ppopt %)

CAMLC_P = ocamlc -g
DEPEND_OCAMLDEP = misc/q_symbol.cmo
ifeq ($(PROFILE), true)
  CAMLOPT_P = ocamlopt -p
  ifeq ($(NATIVE), false) 
    CAMLC_P = ocamlcp -p a
    SYNTAX_PARSER = 
    DEPEND_OCAMLDEP =
  endif
else
  CAMLOPT_P = ocamlopt -inline 25
endif

OPT = -warn-error FPS
ANNOT =
INTERFACE =
ifeq ($(ANNOT), true)
	OPT += -passopt -dtypes
endif
ifeq ($(INTERFACE), true)
	OPT += -passopt -i
endif
OCAMLFIND = ocamlfind
CAMLC = $(OCAMLFIND) $(CAMLC_P) $(OPT) -package "$(PACKAGES)"
CAMLOPT = $(OCAMLFIND) $(CAMLOPT_P) $(OPT) -package "$(PACKAGES)"

ifeq ($(NATIVE), true)
  EXTENSION = cmx
  EXTENSION_LIB = cmxa
  CAML=ocamlopt
  COMPILE = $(CAMLOPT)
  LINK = $(CAMLOPT) -linkpkg gramlib.cmxa
  SYNTAX += -symbol ocaml_compiler=\"native\"
else
  EXTENSION = cmo
  EXTENSION_LIB = cma
  COMPILE = $(CAMLC)
  CAML=ocamlc
  LINK = $(CAMLC) -custom -linkpkg gramlib.cma
  SYNTAX += -symbol ocaml_compiler=\"bytecode\"
endif


INSTALL := install

ifeq ($(NATIVE),true)
.PHONY: cduce_lib.cma
cduce_lib.cma:
	$(HIDE)$(MAKE) NATIVE=false $@
endif

install: all install_bin install_lib install_doc

install_bin:
	@echo "Install binaries"
	$(HIDE)mkdir -p $(BINDIR)
	$(HIDE)$(INSTALL) -m755 $(INSTALL_BINARIES) $(BINDIR)/
	

install_lib:
	@echo "Build META"
	$(HIDE)(sed "s/%REQ%/$(PACKAGES)/" < META.in | sed "s/%VER%/$(VERSION)/" > META)
	$(HIDE)-$(OCAMLFIND) remove cduce
	$(HIDE)-$(OCAMLFIND) install cduce META \
         cduce_lib.cmi $(wildcard *.cma) $(wildcard *.cmxa) $(wildcard *.a) \


uninstall:
	rm -f $(BINDIR)/cduce$(EXE) \
	  $(BINDIR)/cdo2ml$(EXE) \
	  $(BINDIR)/mlcduce_wrapper$(EXE) $(BINDIR)/cduce_mktop
	rm -f $(MANDIR)/man1/cduce.1 \
	  $(MANDIR)/man1/cdo2ml.1
	rm -Rf $(DOCDIR)
	ocamlfind remove cduce

help:
	@echo "GOALS"
	@echo "  cduce : compiles the CDuce command line interpreter"
	@echo "  dtd2cduce: compiles the dtd2cduce tools"
	@echo "  doc : build the documentation"
	@echo "  all : build binaries and libraries"
	@echo "  install : install binaries, man pages, documentation"
	@echo "  clean :  back to the starting point"
	@echo "  uninstall : remove installed files"

# Source directories 

DIRS = misc parser schema typing types compile runtime driver query ocamliface
CLEAN_DIRS = $(DIRS) cdo2cmo tools tests

# Objects to build

SCHEMA_OBJS = \
 schema/schema_pcre.cmo \
 schema/schema_types.cmo \
 schema/schema_xml.cmo \
 schema/schema_common.cmo \
 schema/schema_builtin.cmo \
 schema/schema_validator.cmo \
 schema/schema_parser.cmo \
 schema/schema_converter.cmo 

OBJECTS = \
 driver/config.cmo \
 misc/stats.cmo \
 misc/serialize.cmo misc/custom.cmo \
 misc/state.cmo misc/pool.cmo misc/encodings.cmo misc/bool.cmo \
 misc/pretty.cmo misc/ns.cmo misc/inttbl.cmo misc/imap.cmo \
 misc/html.cmo \
 \
 types/sortedList.cmo types/boolean.cmo types/ident.cmo \
 types/intervals.cmo \
 types/chars.cmo types/atoms.cmo \
 types/normal.cmo \
 types/types.cmo types/sample.cmo types/sequence.cmo types/patterns.cmo \
 types/builtin_defs.cmo \
 \
 compile/lambda.cmo \
 runtime/value.cmo \
 \
 parser/location.cmo  parser/url.cmo \
  \
 parser/ulexer.cmo parser/ast.cmo parser/parser.cmo \
 \
 types/externals.cmo \
 typing/typed.cmo typing/typer.cmo \
 \
 $(SCHEMA_OBJS) \
 \
 runtime/load_xml.cmo runtime/run_dispatch.cmo \
 runtime/explain.cmo \
 runtime/print_xml.cmo runtime/eval.cmo \
 compile/compile.cmo \
 compile/operators.cmo \
 \
 types/builtin.cmo \
 driver/librarian.cmo \
 driver/cduce.cmo \
 runtime/system.cmo

schema/schema_types.ml: schema/schema_types.mli
	cp $^ $@

ML_INTERFACE_OBJS = \
  ocamliface/caml_cduce.cmo \
  ocamliface/mltypes.cmo ocamliface/mlstub.cmo

ifneq ($(ML_INTERFACE), false)
  OBJECTS += $(ML_INTERFACE_OBJS)
endif

ifneq ($(CURL), false)
  OBJECTS += parser/cduce_curl.cmo
  PACKAGES += curl
endif
ifneq ($(NETCLIENT), false)
  OBJECTS += parser/cduce_netclient.cmo
  PACKAGES += netclient
endif

PXP_PACK=pxp-engine pxp-lex-iso88591
ifeq ($(PXP_WLEX), true)
  PXP_PACK += pxp-wlex-utf8
else
  PXP_PACK += pxp-lex-utf8
endif

ifeq ($(PXP),true)
  OBJECTS += runtime/cduce_pxp.cmo
  PACKAGES += $(PXP_PACK)
endif
ifeq ($(EXPAT), true)
  OBJECTS += runtime/cduce_expat.cmo
  PACKAGES += expat
endif


#CQL_OBJECTS= query/query_aggregates.cmo query/query.cmo query/query_parse.cmo 
#CQL_OBJECTS_RUN = query/query_run.cmo
CQL_OBJECTS= query/query_aggregates.cmo
CQL_OBJECTS_RUN=

OBJECTS += $(CQL_OBJECTS)

VALIDATE_OBJECTS := $(shell for o in $(OBJECTS); do echo $$o; if [ "$$o" = "schema/schema_parser.cmo" ]; then exit 0; fi; done)	# all objects until schema_parser.cmo

OBJECTS += $(CQL_OBJECTS_RUN) 
OBJECTS += driver/run.cmo
CDUCE = $(OBJECTS) driver/start.cmo 

ALL_OBJECTS = $(OBJECTS) \
 driver/start.cmo driver/examples.cmo \
 driver/webiface.cmo driver/evaluator.cmo \
 tools/validate.cmo \
 $(ML_INTERFACE_OBJS) parser/cduce_curl.cmo \
 parser/cduce_netclient.cmo \
 runtime/cduce_expat.cmo runtime/cduce_pxp.cmo

ALL_INTERFACES = schema/schema_types.mli 

DEPEND = $(ALL_OBJECTS:.cmo=.ml) $(ALL_OBJECTS:.cmo=.mli) $(ALL_INTERFACES)

INCLUDES = $(DIRS:%=-I %)

cduce: $(CDUCE:.cmo=.$(EXTENSION))
	@echo "Build $@"
	$(HIDE)$(LINK) $(INCLUDES) -o $@ $^ $(EXTRA_LINK_OPTS)

cduce_packed.ml: $(CDUCE:.cmo=.ml)
	rm -f cduce_packed.ml
	ocaml tools/pack.ml $^ > cduce_packed.ml

cduce_packed: cduce_packed.$(EXTENSION)
	$(LINK) $(INCLUDES) -o $@ $^ $(EXTRA_LINK_OPTS)


cduce_lib.$(EXTENSION_LIB): $(OBJECTS:.cmo=.$(EXTENSION))
	@echo "Pack cduce_lib.$(EXTENSION)"
	$(HIDE)$(COMPILE) -o cduce_lib.$(EXTENSION) -pack $^
	@echo "Build $@"
	$(HIDE)$(COMPILE) -a -o $@ cduce_lib.$(EXTENSION)

dtd2cduce: tools/dtd2cduce.ml
	@echo "Build $@"
	$(HIDE)$(OCAMLFIND) $(CAML) -o $@ -ccopt -static -package "$(PXP_PACK) cgi" -linkpkg $^

cduce_validate: $(VALIDATE_OBJECTS:.cmo=.$(EXTENSION)) tools/validate.$(EXTENSION)
	@echo "Build $@"
	$(HIDE)$(LINK) $(INCLUDES) -o $@ $^

mlcduce_wrapper: $(OBJECTS) ocamliface/mlcduce_wrapper.ml
	@echo "Build $@"
	$(HIDE)$(CAMLC) -linkpkg $(INCLUDES) -o $@ odyl.cma camlp4.cma pr_o.cmo $^ $(EXTRA_LINK_OPTS)

cdo2ml: ocamliface/cdo2ml.ml
	@echo "Build $@"
	$(HIDE)ocamlc -o $@ -pp camlp4o -I +camlp4 odyl.cma camlp4.cma pr_o.cmo $^

.PHONY: compute_depend
compute_depend: $(DEPEND_OCAMLDEP)
	echo $(DEPEND)
	@echo "Computing dependencies ..."
	ocamlfind ocamldep -package "$(PACKAGES)" \
		$(INCLUDES) $(SYNTAX_PARSER) $(DEPEND) > depend
clean:
	for i in $(CLEAN_DIRS); do \
	(cd $$i; rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa *~); \
	done
	rm -f ocamliface/cmi2ml ocamliface/asttypes.ml
	rm -f `find . -name "*~"`
	rm -f *.cmi *.cmo *.cma *.cmx *.a *.cmxa *.o *~ META
	rm -f cduce$(EXE) ocamlprof.dump
	rm -f dtd2cduce$(EXE) webiface$(EXE) cduce_validate$(EXE) \
		cdo2ml$(EXE) mlcduce_wrapper$(EXE) evaluator$(EXE)
	rm -Rf prepro package
	rm -f web/www/*.html web/*~
	rm -f web/*.cdo
	rm -f configure.log
	rm -rf web/doc
	rm -f META

distclean: clean
	rm -f Makefile.conf

ocamliface/mltypes.$(EXTENSION): ocamliface/caml_cduce.$(EXTENSION)

$(ALL_OBJECTS:.cmo=.$(EXTENSION)): misc/q_symbol.cmo
$(ALL_INTERFACES): misc/q_symbol.cmo

.SUFFIXES: .ml .mli .cmo .cmi .cmx

misc/q_symbol.cmo: misc/q_symbol.ml
	@echo "Build $@"		  
	$(HIDE)$(CAMLC) -c -pp 'camlp4o pa_extend.cmo q_MLast.cmo' $<

.ml.cmo:
	@echo "Build $@"
	$(HIDE)$(CAMLC) -c $(INCLUDES) $(SYNTAX_PARSER) $<

.ml.cmx:
	@echo "Build $@"
	$(HIDE)$(CAMLOPT) -c $(SYNTAX_PARSER) $(INCLUDES) $<

.mli.cmi:
	@echo "Build $@"
	$(HIDE)$(CAMLC) -c $(SYNTAX_PARSER) $(INCLUDES) $<

include depend

# Documentation

doc: cduce web/site.cdo
	mkdir -p web/doc
	(cd web; ../cduce --run site.cdo --arg doc.xml -o doc)

web/site.cdo: cduce web/xhtml.cdo web/site.cd
	./cduce -I web/ --compile web/site.cd

web/xhtml.cdo: cduce web/xhtml.cd
	./cduce -I web/ --compile web/xhtml.cd

install_doc: doc
	$(HIDE)mkdir -p $(MANDIR)/man1
	$(HIDE)(cd doc; $(MAKE) install INSTALL=$(INSTALL) MANDIR=$(MANDIR) HIDE=$(HIDE))
	mkdir -p $(DOCDIR)/img
	cp web/doc/*.html $(DOCDIR)/
	cp CHANGES INSTALL INSTALL.WIN32 README AUTHORS LICENSE $(DOCDIR)/
	cp web/img/left.gif web/img/right.gif $(DOCDIR)/img


### Pack OCaml modules for the CDuce/OCaml interface


ocamliface/caml_cduce.cmo:
	@cd ocamliface; \
	$(MAKE) PREFIX=$(ML_MODULES) MODEL=$(ML_INTERFACE) \
	        HIDE=$(HIDE) caml_cduce.cmo

ocamliface/caml_cduce.cmx:
	@cd ocamliface; \
	$(MAKE) PREFIX=$(ML_MODULES) MODEL=$(ML_INTERFACE) \
		HIDE=$(HIDE) caml_cduce.cmx

=== doc/Makefile ===
MAN = cduce.1 dtd2cduce.1 cduce_validate.1 cdo2ml.1 cduce_mktop.1
INSTALL_MAN = cduce.1 cdo2ml.1 cduce_mktop.1

all: $(MAN)

.SUFFIXES: .1 .docbook

.docbook.1:
	docbook-to-man $< > $@

install:
	@echo "Install man pages"
	$(HIDE)$(INSTALL) -m644 $(INSTALL_MAN) $(MANDIR)/man1/

=== ocamliface/Makefile ===
# This Makefile generates caml_cduce.cmo/.cmx
# 
# We need the units such that typing/types.cmo  (.cmx)
#
# - If OCaml has been compiled in a directory DIR,
#   you can do:
#     make MODEL=tree PREFIX=DIR
#   e.g.: make caml_cduce.cmo MODEL=tree PREFIX=$HOME/ocaml-3.07
#
# - If you have a (flat) directory DIR will all the compiled units 
#   from utils/ parsing/ and typing/, you can do:
#     make MODEL=flat PREFIX=DIR
#   e.g.: make caml_cduce.cmo MODEL=flat PREFIX=$HOME/godi/lib/ocaml/compiler-lib


OCAML_OBJECTS=$(patsubst %,$(PREFIX)/%, $(UNITS))

OBJECTS=asttypes.ml $(OCAML_OBJECTS)
XOBJECTS=$(OBJECTS:.cmo=.cmx)

ifeq ($(MODEL),flat)
  UNITS= $(subst utils/,,$(UTILS)) \
         $(subst parsing/,,$(PARSING)) \
         $(subst typing/,,$(TYPING))
  INCLUDES = -I $(PREFIX)
  ASTTYPES = $(PREFIX)/asttypes.cmi
else
ifeq ($(MODEL),tree)
  UNITS= $(UTILS) $(PARSING) $(TYPING)
  INCLUDES = -I $(PREFIX)/utils -I $(PREFIX)/parsing -I $(PREFIX)/typing
  ASTTYPES = $(PREFIX)/parsing/asttypes.cmi
else
 $(error Set MODEL=flat or MODEL=tree)
endif
endif

caml_cduce.cmo: asttypes.ml
	@echo "Build $@"
	$(HIDE)ocamlc -pack -o $@ $(INCLUDES) $(OBJECTS)

caml_cduce.cmx: asttypes.ml
	@echo "Build $@"
	$(HIDE)ocamlopt -pack -o $@ $(INCLUDES) $(XOBJECTS)

## Hack to rebuild asttypes.ml from asttypes.cmi
## (because -pack needs .cmo in 3.07)

.PHONY: asttypes.ml
asttypes.ml: cmi2ml
	@echo "Create $@"
	$(HIDE)./cmi2ml Asttypes $(ASTTYPES) > asttypes.ml

cmi2ml: cmi2ml.ml
	@echo "Build $@"
	$(HIDE)ocamlc -o $@ $(INCLUDES) $(OCAML_OBJECTS) $<


UTILS=utils/misc.cmo utils/tbl.cmo utils/config.cmo \
  utils/clflags.cmo utils/consistbl.cmo

PARSING=parsing/longident.cmo

TYPING=typing/ident.cmo typing/path.cmo \
  typing/primitive.cmo typing/types.cmo \
  typing/btype.cmo typing/oprint.cmo \
  typing/subst.cmo typing/predef.cmo \
  typing/datarepr.cmo typing/env.cmo \
  typing/ctype.cmo typing/printtyp.cmo


#UTILS=utils/misc.cmo utils/tbl.cmo utils/config.cmo \
#  utils/clflags.cmo utils/terminfo.cmo utils/ccomp.cmo utils/warnings.cmo \
#  utils/consistbl.cmo
#
#PARSING=parsing/linenum.cmo parsing/location.cmo parsing/longident.cmo \
#  parsing/syntaxerr.cmo parsing/parser.cmo \
#  parsing/lexer.cmo parsing/parse.cmo parsing/printast.cmo
#
#TYPING=typing/ident.cmo typing/path.cmo \
#  typing/primitive.cmo typing/types.cmo \
#  typing/btype.cmo typing/oprint.cmo \
#  typing/subst.cmo typing/predef.cmo \
#  typing/datarepr.cmo typing/env.cmo \
#  typing/typedtree.cmo typing/ctype.cmo \
#  typing/printtyp.cmo typing/includeclass.cmo \
#  typing/mtype.cmo typing/includecore.cmo \
#  typing/includemod.cmo typing/parmatch.cmo \
#  typing/typetexp.cmo typing/stypes.cmo typing/typecore.cmo \
#  typing/typedecl.cmo typing/typeclass.cmo \
#  typing/typemod.cmo

## cduce 0.4.0

=== Makefile ===
include Makefile.conf
include VERSION


ALL_TARGET=cduce cduce_lib.cma
INSTALL_BINARIES=cduce$(EXE)

ifneq ($(ML_INTERFACE), false)
  INSTALL_BINARIES += cduce_mktop
endif


ifeq ($(NATIVE),true)
all: cduce_lib.cmxa
endif

PACKAGES = ulex camlp4 pcre num netstring cgi

# Call make with VERBOSE=true to get a trace of commands

VERBOSE=false

ifneq ($(VERBOSE), true)
   HIDE=@
else
   HIDE=
endif


SYNTAX = -I misc/ q_symbol.cmo \
  -symbol cduce_version=\"$(VERSION)\" \
  -symbol build_date=\"$(shell date +%Y-%m-%d)\" \
  -symbol session_dir=\"$(SESSION_DIR)\" \
  -loc "_loc"

SYNTAX_PARSER = -syntax camlp4o $(SYNTAX:%=-ppopt %)

CAMLC_P = ocamlc -g
DEPEND_OCAMLDEP = misc/q_symbol.cmo
ifeq ($(PROFILE), true)
  CAMLOPT_P = ocamlopt -p -inline 10000
  ifeq ($(NATIVE), false) 
    CAMLC_P = ocamlcp -p a
    SYNTAX_PARSER = 
    DEPEND_OCAMLDEP =
  endif
else
  CAMLOPT_P = ocamlopt -inline 10000
endif

OPT = -warn-error FPSXY
ANNOT =
INTERFACE =
ifeq ($(ANNOT), true)
	OPT += -passopt -dtypes
endif
ifeq ($(INTERFACE), true)
	OPT += -passopt -i
endif
OCAMLFIND = ocamlfind
CAMLC = $(OCAMLFIND) $(CAMLC_P) $(OPT) -package "$(PACKAGES)"
CAMLOPT = $(OCAMLFIND) $(CAMLOPT_P) $(OPT) -package "$(PACKAGES)"

ifeq ($(NATIVE), true)
  EXTENSION = cmx
  EXTENSION_LIB = cmxa
  CAML=ocamlopt
  COMPILE = $(CAMLOPT)
  LINK = $(CAMLOPT) -linkpkg gramlib.cmxa camlp4.cmxa pr_o.cmx
  SYNTAX += -symbol ocaml_compiler=\"native\"
else
  EXTENSION = cmo
  EXTENSION_LIB = cma
  COMPILE = $(CAMLC)
  CAML=ocamlc
  LINK = $(CAMLC) -custom -linkpkg gramlib.cma camlp4.cma pr_o.cmo
  SYNTAX += -symbol ocaml_compiler=\"bytecode\"
endif

ifeq ($(FORPACK),true)
  FORPACKOPT=-passopt -for-pack -passopt Cduce_lib
else
  FORPACKOPT=
endif

INSTALL := install -c

ifeq ($(NATIVE),true)
.PHONY: cduce_lib.cma
cduce_lib.cma:
	$(HIDE)$(MAKE) NATIVE=false $@
endif

install: all install_bin install_lib install_doc

install_bin:
	@echo "Install binaries"
	$(HIDE)mkdir -p $(BINDIR)
	$(HIDE)$(INSTALL) -m755 $(INSTALL_BINARIES) $(BINDIR)/
	

install_lib:
	@echo "Build META"
	$(HIDE)(sed "s/%REQ%/$(PACKAGES)/" < META.in | sed "s/%VER%/$(VERSION)/" > META)
	$(HIDE)-$(OCAMLFIND) remove cduce
	$(HIDE)-$(OCAMLFIND) install cduce META \
         cduce_lib.cmi $(wildcard *.cma) $(wildcard *.cmxa) $(wildcard *.a) \


uninstall:
	rm -f $(BINDIR)/cduce$(EXE) $(BINDIR)/cduce_mktop
	rm -f $(MANDIR)/man1/cduce.1
	rm -Rf $(DOCDIR)
	ocamlfind remove cduce

help:
	@echo "GOALS"
	@echo "  cduce : compiles the CDuce command line interpreter"
	@echo "  dtd2cduce: compiles the dtd2cduce tools"
	@echo "  doc : build the documentation"
	@echo "  all : build binaries and libraries"
	@echo "  install : install binaries, man pages, documentation"
	@echo "  clean :  back to the starting point"
	@echo "  uninstall : remove installed files"

# Source directories 

DIRS = misc parser schema typing types compile runtime driver query ocamliface
CLEAN_DIRS = $(DIRS) tools tests

# Objects to build

OBJECTS = \
 driver/config.cmo misc/stats.cmo misc/custom.cmo misc/encodings.cmo \
 misc/upool.cmo misc/pretty.cmo misc/ns.cmo misc/imap.cmo misc/html.cmo \
 \
 types/compunit.cmo types/sortedList.cmo misc/bool.cmo types/ident.cmo \
 types/intervals.cmo types/chars.cmo types/atoms.cmo types/normal.cmo \
 types/types.cmo compile/auto_pat.cmo \
 types/sequence.cmo types/builtin_defs.cmo \
 \
 runtime/value.cmo \
 \
 schema/schema_pcre.cmo schema/schema_types.cmo \
 schema/schema_xml.cmo schema/schema_common.cmo \
 schema/schema_builtin.cmo schema/schema_validator.cmo \
 \
 types/patterns.cmo \
 \
 compile/lambda.cmo \
 runtime/run_dispatch.cmo runtime/explain.cmo runtime/eval.cmo \
 \
 parser/location.cmo  parser/url.cmo \
 parser/ulexer.cmo parser/ast.cmo parser/parser.cmo \
 \
 typing/typed.cmo typing/typepat.cmo types/externals.cmo typing/typer.cmo \
 compile/compile.cmo \
 \
 schema/schema_parser.cmo schema/schema_converter.cmo \
 runtime/load_xml.cmo runtime/print_xml.cmo compile/operators.cmo types/builtin.cmo \
 driver/librarian.cmo types/sample.cmo \
 compile/print_auto.cmo \
 driver/cduce.cmo \
 \
 runtime/system.cmo query/query_aggregates.cmo

schema/schema_types.ml: schema/schema_types.mli
	cp $^ $@
compile/auto_pat.ml: compile/auto_pat.mli
	cp $^ $@
compile/lambda.ml: compile/lambda.mli
	cp $^ $@

ML_INTERFACE_OBJS = \
  ocamliface/caml_cduce.cmo \
  ocamliface/mltypes.cmo ocamliface/mlstub.cmo

ifneq ($(ML_INTERFACE), false)
  OBJECTS += $(ML_INTERFACE_OBJS)
endif

ifneq ($(CURL), false)
  OBJECTS += parser/cduce_curl.cmo
  PACKAGES += curl
endif
ifneq ($(NETCLIENT), false)
  OBJECTS += parser/cduce_netclient.cmo
  PACKAGES += netclient
endif

PXP_PACK=pxp-engine pxp-lex-iso88591
ifeq ($(PXP_WLEX), true)
  PXP_PACK += pxp-wlex-utf8
else
  PXP_PACK += pxp-lex-utf8
endif

ifeq ($(PXP),true)
  OBJECTS += runtime/cduce_pxp.cmo
  PACKAGES += $(PXP_PACK)
  ALL_TARGET += dtd2cduce
  INSTALL_BINARIES += dtd2cduce
endif
ifeq ($(EXPAT), true)
  OBJECTS += runtime/cduce_expat.cmo
  PACKAGES += expat
endif


all: $(ALL_TARGET)

OBJECTS += driver/run.cmo
CDUCE = $(OBJECTS) driver/start.cmo 

ALL_OBJECTS = $(OBJECTS) \
 driver/start.cmo driver/examples.cmo \
 driver/webiface.cmo driver/evaluator.cmo \
 tools/validate.cmo \
 $(ML_INTERFACE_OBJS) parser/cduce_curl.cmo \
 parser/cduce_netclient.cmo \
 runtime/cduce_expat.cmo runtime/cduce_pxp.cmo

ALL_INTERFACES = schema/schema_types.mli 

DEPEND = $(ALL_OBJECTS:.cmo=.ml) $(ALL_OBJECTS:.cmo=.mli) $(ALL_INTERFACES)

INCLUDES = $(DIRS:%=-I %) -I +camlp4

cduce: $(CDUCE:.cmo=.$(EXTENSION))
	@echo "Build $@"
	$(HIDE)$(LINK) $(INCLUDES) -o $@ $^ $(EXTRA_LINK_OPTS)

cduce_packed.ml: $(CDUCE:.cmo=.ml)
	rm -f cduce_packed.ml
	ocaml tools/pack.ml $^ > cduce_packed.ml

cduce_packed: cduce_packed.$(EXTENSION)
	$(LINK) $(INCLUDES) -o $@ $^ $(EXTRA_LINK_OPTS)


cduce_lib.$(EXTENSION_LIB): $(OBJECTS:.cmo=.$(EXTENSION))
	@echo "Pack cduce_lib.$(EXTENSION)"
	$(HIDE)$(COMPILE) -o cduce_lib.$(EXTENSION) -pack $^
	@echo "Build $@"
	$(HIDE)$(COMPILE) -a -o $@ cduce_lib.$(EXTENSION)

dtd2cduce: tools/dtd2cduce.ml
	@echo "Build $@"
	$(HIDE)$(OCAMLFIND) $(CAML) -o $@ -package "$(PXP_PACK) cgi" -linkpkg $^

.PHONY: compute_depend
compute_depend: $(DEPEND_OCAMLDEP)
	@echo "Computing dependencies ..."
	ocamlfind ocamldep -package "$(PACKAGES)" \
		$(INCLUDES) $(SYNTAX_PARSER) $(DEPEND) > depend
clean:
	for i in $(CLEAN_DIRS); do \
	(cd $$i; rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa *~); \
	done
	(cd ocamliface; make clean)
	rm -f `find . -name "*~"`
	rm -f *.cmi *.cmo *.cma *.cmx *.a *.cmxa *.o *~ META
	rm -f cduce$(EXE) ocamlprof.dump
	rm -f dtd2cduce$(EXE) webiface$(EXE) evaluator$(EXE)
	rm -Rf prepro package
	rm -f web/www/*.html web/*~
	rm -f web/*.cdo
	rm -f configure.log
	rm -rf web/doc
	rm -f META

distclean: clean
	rm -f Makefile.conf

ocamliface/mltypes.$(EXTENSION): ocamliface/caml_cduce.$(EXTENSION)

$(ALL_OBJECTS:.cmo=.$(EXTENSION)): misc/q_symbol.cmo
$(ALL_INTERFACES): misc/q_symbol.cmo

.SUFFIXES: .ml .mli .cmo .cmi .cmx

misc/q_symbol.cmo: misc/q_symbol.ml
	@echo "Build $@"		  
	$(HIDE)$(CAMLC) -c -pp 'camlp4o pa_extend.cmo q_MLast.cmo' $<

.ml.cmo:
	@echo "Build $@"
	$(HIDE)$(CAMLC) -c $(INCLUDES) $(SYNTAX_PARSER) $<

.ml.cmx:
	@echo "Build $@"
	$(HIDE)$(CAMLOPT) $(FORPACKOPT) -c $(SYNTAX_PARSER) $(INCLUDES) $<

.mli.cmi:
	@echo "Build $@"
	$(HIDE)$(CAMLC) -c $(SYNTAX_PARSER) $(INCLUDES) $<

include depend

# Documentation

doc: cduce web/site.cdo
	mkdir -p web/doc
	(cd web; ../cduce --run site.cdo --arg doc.xml -o doc)

web/site.cdo: cduce web/xhtml.cdo web/site.cd
	./cduce -I web/ --compile web/site.cd

web/xhtml.cdo: cduce web/xhtml.cd
	./cduce -I web/ --compile web/xhtml.cd

install_doc: doc
	$(HIDE)mkdir -p $(MANDIR)/man1
	$(HIDE)(cd doc; $(MAKE) install INSTALL="$(INSTALL)" MANDIR=$(MANDIR) HIDE=$(HIDE))
	mkdir -p $(DOCDIR)/img
	cp web/doc/*.html $(DOCDIR)/
	cp CHANGES INSTALL INSTALL.WIN32 README AUTHORS LICENSE $(DOCDIR)/
	cp web/img/left.gif web/img/right.gif $(DOCDIR)/img


### Pack OCaml modules for the CDuce/OCaml interface


ocamliface/caml_cduce.cmo:
	@cd ocamliface; \
	$(MAKE) caml_cduce.cmo

ocamliface/caml_cduce.cmx:
	@cd ocamliface; \
	$(MAKE) caml_cduce.cmx

=== ocamliface/Makefile ===
# This Makefile generates caml_cduce.cmo/.cmx
# It must be called with an OCAML_SRC argument pointing to the root
# of an OCaml source tree.
include ../Makefile.conf

all: caml_cduce.cmo caml_cduce.cmx

STDLIB=$(shell ocamlc -where)
CMI_MAGIC=$(shell grep cmi_magic ocaml-3.08.4/utils/config.mlp)


ifeq ($(FORPACK),true)
  FORPACKOPT1=-for-pack Cduce_lib.Caml_cduce
  FORPACKOPT2=-for-pack Cduce_lib
else
  FORPACKOPT1=
  FORPACKOPT2=
endif

ocaml_files:
	mkdir ocaml_files
	$(HIDE)cp $(patsubst %,$(OCAML_SRC)/%, $(COPY_FILES)) ocaml_files/
	cp location.ml ocaml_files
	mv ocaml_files/asttypes.mli ocaml_files/asttypes.ml
	sed s=STDLIB=$(STDLIB)= config.ml > ocaml_files/config.ml
	grep cmi_magic $(OCAML_SRC)/utils/config.mlp >> ocaml_files/config.ml

caml_cduce.cmo: ocaml_files
	@echo "Build $@"
	(cd ocaml_files; ocamlc $(FORPACKOPT1) $@ -c $(COMPILE_FILES);\
	ocamlc $(FORPACKOPT2) -pack -o $@ $(OBJECTS); \
	cp caml_cduce.cmo caml_cduce.cmi ..)

caml_cduce.cmx: ocaml_files
	@echo "Build $@"
	(cd ocaml_files; ocamlopt $(FORPACKOPT1) $@ -c $(COMPILE_FILES);\
	ocamlopt $(FORPACKOPT2) -pack -o $@ $(XOBJECTS); \
	cp caml_cduce.cmx caml_cduce.o caml_cduce.cmi ..)

clean:
	rm -Rf ocaml_files *~ *.cm*

COPY_FILES=\
  utils/misc.ml utils/tbl.ml \
  utils/consistbl.ml utils/warnings.ml utils/terminfo.ml utils/clflags.ml \
  parsing/asttypes.mli parsing/longident.ml \
  typing/ident.ml typing/path.ml \
  typing/primitive.ml typing/types.ml \
  typing/btype.ml typing/oprint.ml \
  typing/subst.ml typing/predef.ml \
  typing/datarepr.ml typing/env.ml \
  typing/ctype.ml typing/ctype.mli typing/printtyp.ml

COMPILE_FILES=\
  config.ml misc.ml tbl.ml \
  clflags.ml consistbl.ml warnings.ml terminfo.ml \
  location.ml asttypes.ml longident.ml \
  ident.ml path.ml \
  primitive.ml types.ml \
  btype.ml oprint.ml \
  subst.ml predef.ml \
  datarepr.ml env.ml ctype.mli ctype.ml printtyp.ml

COMPILE_FILES_ML=$(filter %.ml,$(COMPILE_FILES))
OBJECTS=$(COMPILE_FILES_ML:.ml=.cmo)
XOBJECTS=$(COMPILE_FILES_ML:.ml=.cmx)

## cduce 0.4.1

=== Makefile ===
--- 
+++ 
@@ -97,7 +97,7 @@
 	@echo "Install binaries"
 	$(HIDE)mkdir -p $(BINDIR)
 	$(HIDE)$(INSTALL) -m755 $(INSTALL_BINARIES) $(BINDIR)/
-	
+
 
 install_lib:
 	@echo "Build META"
@@ -146,6 +146,7 @@
  schema/schema_builtin.cmo schema/schema_validator.cmo \
  \
  types/patterns.cmo \
+ compile/print_auto.cmo \
  \
  compile/lambda.cmo \
  runtime/run_dispatch.cmo runtime/explain.cmo runtime/eval.cmo \
@@ -159,7 +160,6 @@
  schema/schema_parser.cmo schema/schema_converter.cmo \
  runtime/load_xml.cmo runtime/print_xml.cmo compile/operators.cmo types/builtin.cmo \
  driver/librarian.cmo types/sample.cmo \
- compile/print_auto.cmo \
  driver/cduce.cmo \
  \
  runtime/system.cmo query/query_aggregates.cmo
@@ -240,7 +240,7 @@
 
 cduce_lib.$(EXTENSION_LIB): $(OBJECTS:.cmo=.$(EXTENSION))
 	@echo "Pack cduce_lib.$(EXTENSION)"
-	$(HIDE)$(COMPILE) -o cduce_lib.$(EXTENSION) -pack $^
+	$(HIDE)$(COMPILE) -o cduce_lib.$(EXTENSION) $(INCLUDES) -pack $^
 	@echo "Build $@"
 	$(HIDE)$(COMPILE) -a -o $@ cduce_lib.$(EXTENSION)
 
@@ -257,7 +257,7 @@
 	for i in $(CLEAN_DIRS); do \
 	(cd $$i; rm -f *.cmi *.cmo *.cma *.cmx *.o *.a *.cmxa *~); \
 	done
-	(cd ocamliface; make clean)
+	(cd ocamliface; $(MAKE) clean)
 	rm -f `find . -name "*~"`
 	rm -f *.cmi *.cmo *.cma *.cmx *.a *.cmxa *.o *~ META
 	rm -f cduce$(EXE) ocamlprof.dump

=== ocamliface/Makefile ===
--- 
+++ 
@@ -6,7 +6,6 @@
 all: caml_cduce.cmo caml_cduce.cmx
 
 STDLIB=$(shell ocamlc -where)
-CMI_MAGIC=$(shell grep cmi_magic ocaml-3.08.4/utils/config.mlp)
 
 
 ifeq ($(FORPACK),true)
@@ -27,13 +26,13 @@
 
 caml_cduce.cmo: ocaml_files
 	@echo "Build $@"
-	(cd ocaml_files; ocamlc $(FORPACKOPT1) $@ -c $(COMPILE_FILES);\
+	(cd ocaml_files; ocamlc $(FORPACKOPT1) -c $(COMPILE_FILES);\
 	ocamlc $(FORPACKOPT2) -pack -o $@ $(OBJECTS); \
 	cp caml_cduce.cmo caml_cduce.cmi ..)
 
 caml_cduce.cmx: ocaml_files
 	@echo "Build $@"
-	(cd ocaml_files; ocamlopt $(FORPACKOPT1) $@ -c $(COMPILE_FILES);\
+	(cd ocaml_files; ocamlopt $(FORPACKOPT1) -c $(COMPILE_FILES);\
 	ocamlopt $(FORPACKOPT2) -pack -o $@ $(XOBJECTS); \
 	cp caml_cduce.cmx caml_cduce.o caml_cduce.cmi ..)

## cduce 0.5.0

=== Makefile ===
--- 
+++ 
@@ -66,14 +66,14 @@
   EXTENSION_LIB = cmxa
   CAML=ocamlopt
   COMPILE = $(CAMLOPT)
-  LINK = $(CAMLOPT) -linkpkg gramlib.cmxa camlp4.cmxa pr_o.cmx
+  LINK = $(CAMLOPT) -linkpkg camlp4lib.cmxa
   SYNTAX += -symbol ocaml_compiler=\"native\"
 else
   EXTENSION = cmo
   EXTENSION_LIB = cma
   COMPILE = $(CAMLC)
   CAML=ocamlc
-  LINK = $(CAMLC) -custom -linkpkg gramlib.cma camlp4.cma pr_o.cmo
+  LINK = $(CAMLC) -custom -linkpkg camlp4lib.cma
   SYNTAX += -symbol ocaml_compiler=\"bytecode\"
 endif
 
@@ -131,7 +131,7 @@
 # Objects to build
 
 OBJECTS = \
- driver/config.cmo misc/stats.cmo misc/custom.cmo misc/encodings.cmo \
+ driver/cduce_config.cmo misc/stats.cmo misc/custom.cmo misc/encodings.cmo \
  misc/upool.cmo misc/pretty.cmo misc/ns.cmo misc/imap.cmo misc/html.cmo \
  \
  types/compunit.cmo types/sortedList.cmo misc/bool.cmo types/ident.cmo \
@@ -151,7 +151,7 @@
  compile/lambda.cmo \
  runtime/run_dispatch.cmo runtime/explain.cmo runtime/eval.cmo \
  \
- parser/location.cmo  parser/url.cmo \
+ parser/cduce_loc.cmo  parser/url.cmo \
  parser/ulexer.cmo parser/ast.cmo parser/parser.cmo \
  \
  typing/typed.cmo typing/typepat.cmo types/externals.cmo typing/typer.cmo \
@@ -281,7 +281,7 @@
 
 misc/q_symbol.cmo: misc/q_symbol.ml
 	@echo "Build $@"		  
-	$(HIDE)$(CAMLC) -c -pp 'camlp4o pa_extend.cmo q_MLast.cmo' $<
+	$(HIDE)$(CAMLC) -c -pp camlp4orf $<
 
 .ml.cmo:
 	@echo "Build $@"

=== ocamliface/Makefile ===
--- 
+++ 
@@ -19,14 +19,15 @@
 ocaml_files:
 	mkdir ocaml_files
 	$(HIDE)cp $(patsubst %,$(OCAML_SRC)/%, $(COPY_FILES)) ocaml_files/
-	cp location.ml ocaml_files
-	mv ocaml_files/asttypes.mli ocaml_files/asttypes.ml
+	cp location.ml ocaml_files/location.ml
+	cp ocaml_files/asttypes.mli ocaml_files/asttypes.ml
 	sed s=STDLIB=$(STDLIB)= config.ml > ocaml_files/config.ml
 	grep cmi_magic $(OCAML_SRC)/utils/config.mlp >> ocaml_files/config.ml
 
 caml_cduce.cmo: ocaml_files
 	@echo "Build $@"
-	(cd ocaml_files; ocamlc $(FORPACKOPT1) -c $(COMPILE_FILES);\
+	(cd ocaml_files; \
+	ocamlc $(FORPACKOPT1) -c $(COMPILE_FILES);\
 	ocamlc $(FORPACKOPT2) -pack -o $@ $(OBJECTS); \
 	cp caml_cduce.cmo caml_cduce.cmi ..)
 
@@ -42,7 +43,9 @@
 COPY_FILES=\
   utils/misc.ml utils/tbl.ml \
   utils/consistbl.ml utils/warnings.ml utils/terminfo.ml utils/clflags.ml \
-  parsing/asttypes.mli parsing/longident.ml \
+  parsing/asttypes.mli parsing/location.mli \
+  parsing/longident.ml \
+  typing/outcometree.mli \
   typing/ident.ml typing/path.ml \
   typing/primitive.ml typing/types.ml \
   typing/btype.ml typing/oprint.ml \
@@ -51,9 +54,10 @@
   typing/ctype.ml typing/ctype.mli typing/printtyp.ml
 
 COMPILE_FILES=\
+  asttypes.mli outcometree.mli asttypes.ml \
   config.ml misc.ml tbl.ml \
   clflags.ml consistbl.ml warnings.ml terminfo.ml \
-  location.ml asttypes.ml longident.ml \
+  location.mli location.ml longident.ml \
   ident.ml path.ml \
   primitive.ml types.ml \
   btype.ml oprint.ml \

## cduce 0.5.3

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+default: cduce
+
 include Makefile.conf
 include VERSION
 
@@ -14,7 +16,7 @@
 all: cduce_lib.cmxa
 endif
 
-PACKAGES = ulex camlp4 pcre num netstring cgi
+PACKAGES = camlp4 ulex pcre num netstring 
 
 # Call make with VERBOSE=true to get a trace of commands
 
@@ -57,6 +59,7 @@
 ifeq ($(INTERFACE), true)
 	OPT += -passopt -i
 endif
+
 OCAMLFIND = ocamlfind
 CAMLC = $(OCAMLFIND) $(CAMLC_P) $(OPT) -package "$(PACKAGES)"
 CAMLOPT = $(OCAMLFIND) $(CAMLOPT_P) $(OPT) -package "$(PACKAGES)"
@@ -66,7 +69,14 @@
   EXTENSION_LIB = cmxa
   CAML=ocamlopt
   COMPILE = $(CAMLOPT)
-  LINK = $(CAMLOPT) -linkpkg camlp4lib.cmxa
+  LINK = $(CAMLOPT) -linkpkg
+  ifeq ($(NATDYNLINK), true)
+    LINK += dynlink.cmxa
+  endif
+  ifeq ($(ADDICON), true)
+    LINK += cduceres.o
+  endif
+  LINK += camlp4lib.cmxa
   SYNTAX += -symbol ocaml_compiler=\"native\"
 else
   EXTENSION = cmo
@@ -125,7 +135,7 @@
 
 # Source directories 
 
-DIRS = misc parser schema typing types compile runtime driver query ocamliface
+DIRS = misc parser schema typing types compile runtime driver query ocamliface win32
 CLEAN_DIRS = $(DIRS) tools tests
 
 # Objects to build
@@ -196,16 +206,24 @@
 endif
 
 ifeq ($(PXP),true)
-  OBJECTS += runtime/cduce_pxp.cmo
-  PACKAGES += $(PXP_PACK)
-  ALL_TARGET += dtd2cduce
-  INSTALL_BINARIES += dtd2cduce
-endif
+    OBJECTS += runtime/cduce_pxp.cmo
+    PACKAGES += $(PXP_PACK)
+    ifeq ($(CGI),true)
+      OBJECTS += runtime/cduce_pxp.cmo
+      PACKAGES += netcgi1
+      ALL_TARGET += dtd2cduce
+      INSTALL_BINARIES += dtd2cduce
+  endif
+endif
+
 ifeq ($(EXPAT), true)
   OBJECTS += runtime/cduce_expat.cmo
   PACKAGES += expat
 endif
 
+ifeq ($(ADDICON), true)
+  OBJECTS += cduceres.o
+endif
 
 all: $(ALL_TARGET)
 
@@ -224,7 +242,8 @@
 
 DEPEND = $(ALL_OBJECTS:.cmo=.ml) $(ALL_OBJECTS:.cmo=.mli) $(ALL_INTERFACES)
 
-INCLUDES = $(DIRS:%=-I %) -I +camlp4
+INCLUDES = $(DIRS:%=-I %)
+# -I +camlp4
 
 cduce: $(CDUCE:.cmo=.$(EXTENSION))
 	@echo "Build $@"
@@ -246,7 +265,7 @@
 
 dtd2cduce: tools/dtd2cduce.ml
 	@echo "Build $@"
-	$(HIDE)$(OCAMLFIND) $(CAML) -o $@ -package "$(PXP_PACK) cgi" -linkpkg $^
+	$(HIDE)$(OCAMLFIND) $(CAML) -o $@ -package "$(PXP_PACK) netcgi1" -linkpkg $^
 
 .PHONY: compute_depend
 compute_depend: $(DEPEND_OCAMLDEP)
@@ -297,13 +316,16 @@
 
 include depend
 
+cduceres.o: win32/cduce.rc win32/cduce_logo-bw.ico
+	(cd win32; windres -i cduce.rc -o cduceres.o; mv cduceres.o ..)
+
 # Documentation
 
 doc: cduce web/site.cdo
 	mkdir -p web/doc
 	(cd web; ../cduce --run site.cdo --arg doc.xml -o doc)
 
-web/site.cdo: cduce web/xhtml.cdo web/site.cd
+web/site.cdo: cduce web/xhtml.cdo web/site.cd web/siteTypes.cd
 	./cduce -I web/ --compile web/site.cd
 
 web/xhtml.cdo: cduce web/xhtml.cd

=== doc/fomanual/Makefile ===
# include ../../Makefile.distrib
include ../../VERSION
JAVA_HOME=/usr/java/jre1.5.0
BUILD_DIR:=$(PWD:/doc/fomanual=)
CDUCE=$(BUILD_DIR)/cduce
FOP=fop-0.20.5/fop.sh 
#FOP=fop

all: manual.pdf tutorial.pdf 

# tutorial:
# 	(cd ../../web && $(CDUCE) ../doc/fomanual/xml2fo.cd  \
#             --arg tutorial.xml tutorial_fo.xml $(VERSION))

# manual:
# 	(cd ../../web && $(CDUCE) ../doc/fomanual/xml2fo.cd  \
#             --arg manual.xml manual_fo.xml $(VERSION))

# tutorial.fo: xml2fo.cd ../../web/tutorial.xml ../../web/tutorial/*.xml ../../web/siteTypes.cd
# 	(cd ../../web && ${CDUCE} ../doc/fomanual/xml2fo.cd \
# 		--arg tutorial.xml tutorial.fo ${VERSION})

# manual.fo: xml2fo.cd ../../web/manual.xml ../../web/manual/*.xml ../../web/siteTypes.cd
# 	(cd ../../web && ${CDUCE} ../doc/fomanual/xml2fo.cd  \
# 		--arg manual.xml manual.fo ${VERSION})

echo:
	@echo ${PWD}
	@echo ${BUILD_DIR}
	@echo ${CDUCE}

xml2fo.cdo: xml2fo.cd ../../web/siteTypes.cd
	${CDUCE} --compile -I ../../web xml2fo.cd

manual.fo: ../../web/manual.xml ../../web/manual/* xml2fo.cdo
	(cd ../../web && ${CDUCE} --run -I ../doc/fomanual xml2fo.cdo \
		--arg manual.xml manual.fo ${VERSION})

tutorial.fo: ../../web/tutorial.xml ../../web/tutorial/* xml2fo.cdo
	(cd ../../web && ${CDUCE} --run -I ../doc/fomanual xml2fo.cdo \
		--arg tutorial.xml tutorial.fo ${VERSION})

# tutorial_pdf: tutorial
# 	$(FOP) tutorial_fo.xml tutorial.pdf

# manual_pdf: manual
# 	$(FOP) manual_fo.xml manual.pdf 

install:
	scp manual.pdf tutorial.pdf cduce@di.ens.fr:public_html/papers/

.SUFFIXES: .fo .pdf

.fo.pdf:
	${FOP} $< $*.pdf

clean::
	rm -f *~
	rm -f xml2fo.cdo
	rm -f tutorial_fo.xml manual_fo.xml
	rm -f tutorial.fo manual.fo
	rm -f tutorial.pdf manual.pdf

#
# END
#

=== debian/changelog ===
cduce (0.5.3-3) unstable; urgency=low

  [ Stéphane Glondu ]
  * Switch to dh-ocaml 0.9 (Closes: #599297)
  * Switch source package format to 3.0 (quilt)
  * debian/rules: switch to dh with overrides
  * debian/control:
    - add myself to Uploaders, and remove Stefano
    - bump Standards-Version to 3.9.1 (no changes)

  [ Mehdi Dogguy ]
  * Team upload.
  * Upload to unstable.
  * Don't compile to native code on native architectures without natdynlink.
    It won't work because cduce needs Camlp4lib, which need Dynlink.
  * Don't install copies of manpages (Closes: #577214).

 -- Mehdi Dogguy <mehdi@debian.org>  Fri, 22 Apr 2011 13:08:30 +0200

cduce (0.5.3-2) unstable; urgency=low

  [ Stephane Glondu ]
  * Add build-dependency to quilt and README.source
  * Add a patch to explicitly link dynlink.cma in the bytecode version
    (fixes FTBFS on bytecode-only architectures)
  * Add debian/clean

  [ Stefano Zacchiroli ]
  * debian/control: add version requirement on libcurl-ocaml-dev build-dep
    to entail dep-wait

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 25 Mar 2009 10:21:48 +0100

cduce (0.5.3-1) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * add Homepage field to debian/control

  [ Ralf Treinen ]
  * debian/watch: use info from download.html web pages (closes: Bug#450060)

  [ Pietro Abate ]
  * switch packaging to git
  * new upstream release (0.5.3)
  * recompile with ocaml 3.11
  * bump Standards-Version to 3.8.1 (no changes)
  * add a build-dependency on dh-ocaml
  * use @OCamlStdlibDir@ in cduce.dirs.in
  * remove dpatch dependency
  * bump debhelper compatibility to 7
  * set Maintainer to d-o-m
  * add myself to Uploaders

 -- Pietro Abate <pietro.abate@pps.jussieu.fr>  Mon, 23 Mar 2009 17:47:53 +0100

cduce (0.5.0-2) unstable; urgency=low

  * uploading to unstable

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 09 Sep 2007 10:13:57 +0200

cduce (0.5.0-1) experimental; urgency=low

  [ Stefano Zacchiroli ]
  * new upstream release (0.5.0)
  * rebuild against OCaml 3.10 (a requirement for this new upstream)
  * bump debheper compatibility level and dependencies to 5
  * debian/rules
    - use as a replacement for .in files the same stem ("@OCamlABI@") used by
      the CDBS class, to ease future migration to that
    - build with ocamlc on ia64 to workaround a FTBFS on that arch, thanks to
      Julien Cristau for the patch (closes: #419892)
  * debian/control
    - add build-dep on camlp4(-extra), which is now in a separate package
    - removed old versioned deps, no longer needed post-etch

  [ Thomas Petazzoni ]
  * Fix typos in package description (closes: #399797)

 -- Stefano Zacchiroli <zack@debian.org>  Sun, 12 Aug 2007 19:34:00 +0200

cduce (0.4.1-1) unstable; urgency=low

  * New upstream release 0.4.1
  * Do not put the Debian package version in the Build-Depends and Depends

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Tue,  3 Oct 2006 19:21:24 +0200

cduce (0.4.0-4.1) unstable; urgency=low

  * NMU.

  [ Julien Cristau ]
  * Bump build-deps on libpcre-ocaml-dev and libocamlnet-dev for new upstream
    release of pcre-ocaml.

  [ Samuel Mimram ]
  * Remove control.in as per new ocaml policy.

 -- Samuel Mimram <smimram@debian.org>  Thu, 14 Sep 2006 20:16:49 +0000

cduce (0.4.0-4) unstable; urgency=low

  * Bump up Standards-Version to 3.7.2.
  * Update to ocaml 3.09.2.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sun, 21 May 2006 12:23:19 +0200

cduce (0.4.0-3) unstable; urgency=low

  * Update to ocaml 3.09.1.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sat, 13 May 2006 11:45:29 +0200

cduce (0.4.0-2) unstable; urgency=low

  * Update to ocaml 3.09.
  * No longer hardcoding OCaml's ABI in debian/* files.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sun,  4 Dec 2005 23:03:09 +0100

cduce (0.4.0-1) unstable; urgency=low

  * New upstream version 0.4.0. Changes since 0.3.92:
   - Adapted to OCaml 3.09.
   - To build the OCaml/CDuce interface, OCaml sources are now needed.

  * Drop dependency against ocaml-compiler-libs, add dependency against
    ocaml-source, and build the OCaml/CDuce interface using the compiler
    sources.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Mon, 31 Oct 2005 01:20:25 +0100

cduce (0.3.92-1) unstable; urgency=low

  * New upstream version 0.3.92. Changes since 0.3.91:
   - Tools:
    * Build and install dtd2cduce when PXP is available.
    * Display of location for errors and warnings compatible with OCaml.
   - Language:
    * Better error messages for xtransform.
   - Bug fix:
    * Forgot PLIST.godi in the package.
  * debian/control
    - versioned dependencies on curl and pcre

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Thu, 20 Oct 2005 19:31:08 +0200

cduce (0.3.91-3) unstable; urgency=low

  * Recompile against new version of Curl.

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Wed, 14 Sep 2005 22:44:13 +0200

cduce (0.3.91-2) unstable; urgency=low

  Changes by Thomas Petazzoni
  * Recompile with new version of netstring.

  Changes by Stefano Zacchiroli:
  * debian/control
    - bumped standards-version
    - versioned dependencies on ocamlnet

 -- Thomas Petazzoni <thomas.petazzoni@enix.org>  Sun, 31 Jul 2005 12:04:59 +0200

cduce (0.3.91-1) unstable; urgency=low

  * New upstream version of cduce. Changes:
   - Language:
    * Added split_atom, make_atom. Removed atom_of.
    * Added char_of_int built_in function.
    * Now int_of also accepts octal binary and hexadecimals.
    * The field access also works for XML element attributes.
    * More catchable exceptions (for load_xml, load_file, etc).
    * namespaces, schemas, "using" identifiers are now exported.
    * "open" statement.

   - Implementation:
    * More efficient implementation of records at runtime.
    * Clean-up of the internal representation.
    * The XML Schemas are now parsed only at compile time.
    * The automata for pattern matching are now produced at compile time.

   - Tools:


=== debian/control ===
Source: cduce
Section: interpreters
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>,
 Pietro Abate <pietro.abate@pps.jussieu.fr>
Build-Depends:
 debhelper (>= 7.2.11~),
 dh-ocaml (>= 0.9~),
 ocaml-nox (>= 3.11.1-3~),
 camlp4-extra,
 ocaml-source (>= 3.11.0),
 libpcre-ocaml-dev (>= 6.0.1-2~),
 libocamlnet-ocaml-dev (>= 2.2.9-7~),
 libexpat-ocaml-dev (>= 0.9.1+debian1-6~),
 libcurl-ocaml-dev (>= 0.5.1-2~),
 ocaml-ulex (>= 1.1-2~),
 chrpath,
 bzip2
Standards-Version: 3.9.1
Homepage: http://www.cduce.org
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/cduce.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/cduce.git

Package: cduce
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: programming language adapted to the manipulation of XML data
 CDuce is a modern programming language adapted to the manipulation of
 XML documents.
 .
 Some of CDuce's peculiar features:
  - XML objects can be manipulated as first-class citizen values:
    elements, sequences, tags, characters and strings, attribute sets;
    sequences of XML elements can be specified by regular expressions,
    which also apply to characters strings;
  - functions themselves are first-class values, they can be
    manipulated, stored in data structure, returned by a function,...;
  - a powerful pattern matching operation can perform complex
    extractions from sequences of XML elements;
  - a rich type algebra, with recursive types and arbitrary boolean
    combinations (union, intersection, complement) allows precise
    definitions of data structures and XML types; general purpose
    types and types constructors are taken seriously (products,
    extensible records, arbitrary precision integers with interval
    constraints, Unicode characters);
  - polymorphism through a natural notion of subtyping, and overloaded
    functions with dynamic dispatch; - an highly-effective type-driven
    compilation schema.
 .
 CDuce is fast, functional, type-safe, and conforms to basic
 standards: Unicode, XML, DTD, Namespaces are fully supported, partial
 support of XML Schema validation is in alpha testing (and
 undocumented) while queries are being implemented.

## cduce 0.5.4

=== ocamliface/Makefile ===
--- 
+++ 
@@ -41,6 +41,7 @@
 	rm -Rf ocaml_files *~ *.cm*
 
 COPY_FILES=\
+  typing/annot.mli \
   utils/misc.ml utils/tbl.ml \
   utils/consistbl.ml utils/warnings.ml utils/terminfo.ml utils/clflags.ml \
   parsing/asttypes.mli parsing/location.mli \
@@ -57,7 +58,7 @@
   asttypes.mli outcometree.mli asttypes.ml \
   config.ml misc.ml tbl.ml \
   clflags.ml consistbl.ml warnings.ml terminfo.ml \
-  location.mli location.ml longident.ml \
+  location.mli location.ml annot.mli longident.ml \
   ident.ml path.ml \
   primitive.ml types.ml \
   btype.ml oprint.ml \

=== debian/changelog ===
cduce (0.5.4-1build3) precise; urgency=low

  * Rebuild for OCaml 3.12.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 19 Nov 2011 16:57:13 +0000

cduce (0.5.4-1build2) precise; urgency=low

  * Rebuild for new OCaml library ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Nov 2011 21:03:00 +0000

cduce (0.5.4-1build1) precise; urgency=low

  * Rebuild for new libocamlnet-ocaml-dev ABI.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Oct 2011 11:47:30 +0100

cduce (0.5.4-1) unstable; urgency=low

  * Team upload
  * New upstream release
  * Bump Standards-Version to 3.9.2

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Jul 2011 21:22:36 +0200

=== debian/rules ===
#!/usr/bin/make -f
PACKAGE = cduce

include /usr/share/ocaml/ocamlinit.mk
ifeq ($(OCAML_NATDYNLINK),yes)
  MAKE_OPTS := "NATIVE=true"
else
  MAKE_OPTS := "NATIVE=false"
endif

LIBDIR=$(CURDIR)/debian/cduce/$(OCAML_STDLIB_DIR)
DOCDIR=$(CURDIR)/debian/cduce/usr/share/doc/cduce/html
BINDIR=$(CURDIR)/debian/cduce/usr/bin
MANDIR=$(CURDIR)/debian/cduce/usr/share/doc/man

CONFIGURE_OPTS := --prefix=/usr \
  --mliface=debian/ocaml-$(OCAML_ABI) \
  --with-curl \
  --without-netclient \
  --with-expat \
  --without-pxp

%:
	dh --with ocaml $@

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	tar -C debian -xjf /usr/src/ocaml-source-$(OCAML_ABI).tar.bz2
	./configure  $(CONFIGURE_OPTS)

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) $(MAKE_OPTS) all doc

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	touch Makefile.conf
	[ ! -f Makefile ] || $(MAKE) $(MAKE_OPTS) clean
	-$(RM) Makefile.conf
	-$(RM) -rf debian/ocaml-$(OCAML_ABI)/

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) $(MAKE_OPTS) DOCDIR=$(DOCDIR) BINDIR=$(BINDIR) MANDIR=$(MANDIR) OCAMLFIND_DESTDIR=$(LIBDIR) OCAMLFIND_LDCONF=ignore install

	# Remove the wrong RPATH
	chrpath -d $(BINDIR)/cduce

	# CDuce Makefile installs all the documentation in DOCDIR, including
	# README, LICENSE, and so on. We don't want these. Let's hack.
	find $(DOCDIR) -maxdepth 1 -not -name "*.html" -not -name "img" -exec rm {} \;
	-$(RM) -rf $(MANDIR)

.PHONY: override_dh_ocaml
override_dh_ocaml:
	dh_ocaml --runtime-map cduce

## cduce 0.5.5

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 all: cduce_lib.cmxa
 endif
 
-PACKAGES = camlp4 ulex pcre num netstring 
+PACKAGES = dynlink camlp4 ulex pcre num netstring 
 
 # Call make with VERBOSE=true to get a trace of commands

=== debian/changelog ===
cduce (0.5.5-1build2) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 22:01:45 +0000

cduce (0.5.5-1build1) saucy; urgency=low

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 09 May 2013 18:05:49 +0100

cduce (0.5.5-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Mar 2012 22:51:57 +0100

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
  ocaml-ulex (>= 1.1-2~),
  chrpath,
  bzip2
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://www.cduce.org
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/cduce.git
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/cduce.git
